org.eclipse.jetty.webapp

## Interface Configuration

All Known Implementing Classes:
  AbstractConfiguration, AnnotationConfiguration, CloneConfiguration, EnvConfiguration, FragmentConfiguration, JettyWebXmlConfiguration, MetaInfConfiguration, PlusConfiguration, TagLibConfiguration, WebInfConfiguration, WebXmlConfiguration

    public interface Configuration

Base Class for WebApplicationContext Configuration. This class can be extended to customize or extend the configuration of the WebApplicationContext.

### Method Summary

Methods
`void` `cloneConfigure(WebAppContext template, WebAppContext context)` Clone configuration instance.
`void` `configure(WebAppContext context)` Configure WebApp.
`void` `deconfigure(WebAppContext context)` DeConfigure WebApp.
`void` `destroy(WebAppContext context)` Destroy WebApp.
`void` `postConfigure(WebAppContext context)` Clear down after configuration.
`void` `preConfigure(WebAppContext context)` Set up for configuration.

### Method Detail

#### preConfigure

    void preConfigure(WebAppContext context)
                      throws Exception

Set up for configuration.

Typically this step discovers configuration resources

Parameters:
  `context` - The context to configure
Throws:
  `Exception`

#### configure

    void configure(WebAppContext context)
                   throws Exception

Configure WebApp.

Typically this step applies the discovered configuration resources to either the `WebAppContext` or the associated `MetaData`.

Parameters:
  `context` - The context to configure
Throws:
  `Exception`

#### postConfigure

    void postConfigure(WebAppContext context)
                       throws Exception

Clear down after configuration.

Parameters:
  `context` - The context to configure
Throws:
  `Exception`

#### deconfigure

    void deconfigure(WebAppContext context)
                     throws Exception

DeConfigure WebApp. This method is called to undo all configuration done. This is called to allow the context to work correctly over a stop/start cycle

Parameters:
  `context` - The context to configure
Throws:
  `Exception`

#### destroy

    void destroy(WebAppContext context)
                 throws Exception

Destroy WebApp. This method is called to destroy a webappcontext. It is typically called when a context is removed from a server handler hierarchy by the deployer.

Parameters:
  `context` - The context to configure
Throws:
  `Exception`

#### cloneConfigure

    void cloneConfigure(WebAppContext template,
                      WebAppContext context)
                        throws Exception

Clone configuration instance.

Configure an instance of a WebAppContext, based on a template WebAppContext that has previously been configured by this Configuration.

Parameters:
  `template` - The template context
  `context` - The context to configure
Throws:
  `Exception`